/*******************************************************************************
 * FoxQuickMarketUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxQuickMarketUI extends Object within FoxUI
    native(UI)
    config(UI);

enum ECanPurchaseError
{
    ECPE_AlreadyOwned,
    ECPE_CanPurchase,
    ECPE_BadPrereq,
    ECPE_MAX
};

var private FoxQuickMarketWidget MarketWidget;
var private FoxQuickMarketWidget LandingPageMarketWidget;
var private OnlineImageDownloaderWeb ImageDownloader;
var private const localized string LocErrorAlreadyOwned;
var private const localized string LocErrorInGameLabel;
var private const localized string LocErrorNotApplicableLabel;
var private const localized string LocNavToStoreTitle;
var private const localized string LocNavToStoreBody;
var private const localized string LocPurchaseCurrencyTitle;
var private const localized string LocPurchaseCurrencyBody_Pending;
var private const localized string LocPurchaseCurrencyBody_Complete;
var private const localized string LocPurchaseCurrencyBody_Failed;
var protected transient bool bErrorPopup;
var private bool bIsShowing;
var private transient bool bMarketPreloadedArmory;
var private transient bool bGoingToTravelToArmory;
var protected transient int NavToItemID;
var private array<string> NeededURLs;
var private int ZCoinRolloverCount;
var const config array<config int> NonNavigableUnlockTypes;

function Initialize()
{
    ImageDownloader = new (self) class'OnlineImageDownloaderWeb';
    ImageDownloader.__OnOnlineImageDownloaded__Delegate = OnImageDownloadedFromWeb;
    ImageDownloader.Initialize();
    //return;    
}

function CreateLandingPageMarket(int X, int Y)
{
    local string LandingPagePath;

    // End:0xE0
    if(Outer.RootPanel != none)
    {
        LandingPagePath = as_AddLandingPageMarket(X, Y);
        LandingPageMarketWidget = FoxQuickMarketWidget(Outer.GetVariableObject(LandingPagePath, class'FoxQuickMarketWidget'));
        // End:0x9F
        if(LandingPageMarketWidget == none)
        {
            return;
        }
        LandingPageMarketWidget.Initialize(self, true);
        LandingPageMarketWidget.SetFeaturedTimerPaused(0);
    }
    //return;    
}

function string as_AddLandingPageMarket(int X, int Y)
{
    return Outer.ActionScriptString("_root.addLandingPageMarket");
    //return ReturnValue;    
}

// Export UFoxQuickMarketUI::execTick(FFrame&, void* const)
native function Tick(float DeltaTime);

event ScriptTick(float DeltaTime)
{
    ImageDownloader.Tick(DeltaTime);
    //return;    
}

function Show()
{
    local GFxObject Container;

    // End:0x58
    if(MarketWidget != none)
    {
        MarketWidget.Cleanup();
        MarketWidget.RemoveMovieClip();
        MarketWidget = none;
    }
    Container = Outer.GetVariableObject(class'FoxQuickMarketWidget'.default.ContainerName);
    // End:0x154
    if(Container != none)
    {
        MarketWidget = FoxQuickMarketWidget(Container.AttachMovieClip(class'FoxQuickMarketWidget'.default.WidgetName, "QuickMarket", class'FoxQuickMarketWidget'));
        // End:0x154
        if(MarketWidget != none)
        {
            MarketWidget.Initialize(self);
            bIsShowing = true;
            J0x154:
        }
        // End:0x154
        else
        {
        }
    }
    ZCoinRolloverCount = 0;
    //return;    
}

function Hide()
{
    // End:0x58
    if(MarketWidget != none)
    {
        MarketWidget.Cleanup();
        MarketWidget.RemoveMovieClip();
        MarketWidget = none;
    }
    Outer.PCOwner.OnlineSub.StoreInterface.ClearTitleStorePurchaseCompleteDelegate(0, OnTitleStorePurchaseComplete);
    Outer.PCOwner.OnlineSub.StoreInterface.HideTitleStoreIcon();
    ZCoinRolloverCount = 0;
    bIsShowing = false;
    //return;    
}

function Cleanup()
{
    Hide();
    Outer.PCOwner.OnlineSub.StoreInterface.ClearFinalizePurchaseCurrencyDelegate(0, OnZCoinPurchaseCompleted);
    Outer.PCOwner.OnlineSub.StoreInterface.ClearInitPurchaseCurrencyDelegate(0, OnInitZCoinPurchase);
    // End:0x146
    if(LandingPageMarketWidget != none)
    {
        LandingPageMarketWidget.Cleanup();
        LandingPageMarketWidget.RemoveMovieClip();
        LandingPageMarketWidget = none;
    }
    // End:0x1AF
    if(ImageDownloader != none)
    {
        ImageDownloader.ClearAllDownloads();
        ImageDownloader.__OnOnlineImageDownloaded__Delegate = None;
        ImageDownloader = none;
    }
    //return;    
}

event bool IsShowing()
{
    return bIsShowing;
    //return ReturnValue;    
}

function ei_OnCancelled()
{
    Hide();
    Outer.Menu.StopStoreMusic();
    Outer.PCOwner.OnlineSub.StoreInterface.HideTitleStoreIcon();
    //return;    
}

function ei_onZCoinsRollover(string Arg, int Focused)
{
    // End:0x1D
    if(Focused == 1)
    {
        ++ ZCoinRolloverCount;
    }
    // End:0x28
    else
    {
        -- ZCoinRolloverCount;
    }
    // End:0x9B
    if(ZCoinRolloverCount > 0)
    {
        Outer.PCOwner.OnlineSub.StoreInterface.ShowTitleStoreIcon(1);
    }
    // End:0xFA
    else
    {
        Outer.PCOwner.OnlineSub.StoreInterface.HideTitleStoreIcon();
    }
    //return;    
}

function ei_rolloverFeaturedItem(int Focused)
{
    // End:0x37
    if(MarketWidget != none)
    {
        MarketWidget.SetFeaturedTimerPaused(Focused);
    }
    //return;    
}

function OnZCoinPurchaseCompleted(const UniqueNetId ForId, byte LocalUserNum, bool bSuccess)
{
    local DialogBoxProperties Props;

    Outer.PCOwner.OnlineSub.StoreInterface.QueryFunds(Outer.PCOwner.PlayerReplicationInfo.UniqueId);
    Outer.PCOwner.OnlineSub.StoreInterface.QueryProfile(Outer.PCOwner.PlayerReplicationInfo.UniqueId);
    Outer.PCOwner.OnlineSub.StoreInterface.ClearFinalizePurchaseCurrencyDelegate(0, OnZCoinPurchaseCompleted);
    Props.DialogType = 1;
    Props.TitleText = LocPurchaseCurrencyTitle;
    Props.bCloseOnButtonPress = true;
    // End:0x25A
    if(bSuccess)
    {
        Props.BodyText = LocPurchaseCurrencyBody_Complete;
    }
    // End:0x280
    else
    {
        Props.BodyText = LocPurchaseCurrencyBody_Failed;
    }
    Outer.ShowDialogBox(Props);
    //return;    
}

function OnInitZCoinPurchase(const UniqueNetId ForId, byte LocalUserNum, bool bSuccess, string UsableURL)
{
    local DialogBoxProperties Props;

    Outer.PCOwner.OnlineSub.StoreInterface.ClearInitPurchaseCurrencyDelegate(0, OnInitZCoinPurchase);
    // End:0x1A8
    if(!bSuccess)
    {
        Props.DialogType = 1;
        Props.TitleText = LocPurchaseCurrencyTitle;
        Props.bCloseOnButtonPress = true;
        Props.BodyText = LocPurchaseCurrencyBody_Failed;
        Outer.ShowDialogBox(Props);
        Outer.PCOwner.OnlineSub.StoreInterface.ClearFinalizePurchaseCurrencyDelegate(0, OnZCoinPurchaseCompleted);
    }
    // End:0x27F
    else
    {
        // End:0x27F
        if(((UsableURL != "") && Outer.Menu != none) && Outer.Menu.ShouldShowWebPageWarning())
        {
            Outer.PCOwner.OnlineSub.PlayerInterfaceEx.ShowWebPageUI(UsableURL);
        }
    }
    //return;    
}

function ei_OnZCoinsClickedPurchase(string Arg)
{
    local DialogBoxProperties Props;

    Outer.PCOwner.OnlineSub.StoreInterface.AddFinalizePurchaseCurrencyDelegate(0, OnZCoinPurchaseCompleted);
    Outer.PCOwner.OnlineSub.StoreInterface.AddInitPurchaseCurrencyDelegate(0, OnInitZCoinPurchase);
    Outer.PCOwner.OnlineSub.StoreInterface.InitPurchaseCurrency(Outer.PCOwner.PlayerReplicationInfo.UniqueId, int(Arg));
    Props.DialogType = 3;
    Props.TitleText = LocPurchaseCurrencyTitle;
    Props.BodyText = LocPurchaseCurrencyBody_Pending;
    Props.bCloseOnButtonPress = true;
    Props.bShowTimer = true;
    Outer.ShowDialogBox(Props);
    //return;    
}

function ei_OnZCoinsClicked(string Arg)
{
    // End:0x12A
    if(Outer.GetWorldInfo().IsConsoleBuild())
    {
        Outer.PCOwner.OnlineSub.StoreInterface.AddTitleStorePurchaseCompleteDelegate(0, OnTitleStorePurchaseComplete);
        Outer.PCOwner.OnlineSub.StoreInterface.ShowTitleStore(Arg, ((Arg == "") ? 0 : 1));
    }
    // End:0x149
    else
    {
        Outer.ShowZCoinPurchaseDialog();
    }
    //return;    
}

event SetGPAndZP(int GPAmount, int ZPAmount, optional bool bGPAmountValid, optional bool bZPAmountValid)
{
    bGPAmountValid = true;
    bZPAmountValid = true;
    // End:0x5E
    if(MarketWidget != none)
    {
        MarketWidget.SetGPAndZP(GPAmount, ZPAmount, bGPAmountValid, bZPAmountValid);
    }
    //return;    
}

function OnTitleStorePurchaseComplete(bool bResult)
{
    // End:0xB4
    if(bResult)
    {
        Outer.PCOwner.OnlineSub.StoreInterface.QueryFunds(Outer.PCOwner.PlayerReplicationInfo.UniqueId);
    }
    Outer.PCOwner.OnlineSub.StoreInterface.ClearTitleStorePurchaseCompleteDelegate(0, OnTitleStorePurchaseComplete);
    //return;    
}

function SetImagesNeeded(array<string> URLs)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7B [Loop If]
    if(I < URLs.Length)
    {
        // End:0x6D
        if(NeededURLs.Find(URLs[I]) == -1)
        {
            NeededURLs.AddItem(URLs[I]);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    ImageDownloader.RequestOnlineImages(NeededURLs);
    //return;    
}

function OnImageDownloadedFromWeb(OnlineImageDownload CachedEntry)
{
    // End:0x66
    if(MarketWidget != none)
    {
        MarketWidget.UpdateImageForURL(CachedEntry.URL, CachedEntry.Texture);
    }
    // End:0xCC
    if(LandingPageMarketWidget != none)
    {
        LandingPageMarketWidget.UpdateImageForURL(CachedEntry.URL, CachedEntry.Texture);
    }
    //return;    
}

function ei_incrementFeaturedIndex()
{
    IncrementFeaturedIndex();
    //return;    
}

function ei_decrementFeaturedIndex()
{
    DecrementFeaturedIndex();
    //return;    
}

event IncrementFeaturedIndex()
{
    // End:0x31
    if(MarketWidget != none)
    {
        MarketWidget.IncrementFeatured();
    }
    // End:0x5F
    else
    {
        // End:0x5F
        if(LandingPageMarketWidget != none)
        {
            LandingPageMarketWidget.IncrementFeatured();
        }
    }
    //return;    
}

event DecrementFeaturedIndex()
{
    // End:0x31
    if(MarketWidget != none)
    {
        MarketWidget.DecrementFeatured();
    }
    // End:0x5F
    else
    {
        // End:0x5F
        if(LandingPageMarketWidget != none)
        {
            LandingPageMarketWidget.DecrementFeatured();
        }
    }
    //return;    
}

// Export UFoxQuickMarketUI::execIsOwnedForAllOwnedReceivers(FFrame&, void* const)
native function bool IsOwnedForAllOwnedReceivers(int UnlockID);

function bool DoesOwnAValidReceiverForMod(int ModUnlockID)
{
    local FoxTypes.EPurchaseState PurchaseState;
    local array<int> ReceiverUnlocks;
    local FoxItemCacheInventory InventoryCache;
    local int I;

    // End:0x132
    if(class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
    {
        class'FoxUnlockInfo'.static.GetUnlocksForUnlockType(ReceiverUnlocks, 26);
        I = 0;
        J0x60:
        // End:0x132 [Loop If]
        if(I < ReceiverUnlocks.Length)
        {
            PurchaseState = Outer.GetItemPurchasedStateFromID(ReceiverUnlocks[I]);
            // End:0x124
            if(((PurchaseState == 4) || PurchaseState == 3) && class'FoxLoadoutInfo'.static.IsModIDValidForWeaponID(ModUnlockID, ReceiverUnlocks[I]))
            {
                return true;
            }
            ++ I;
            // [Loop Continue]
            goto J0x60;
        }
    }
    return false;
    //return ReturnValue;    
}

function FoxQuickMarketUI.ECanPurchaseError CanPurchase(StoreMetaData StoreItem, out int AssociatedUnlockID)
{
    local InventoryMetaData InvMetaData;
    local array<InventoryMetaData> InventoryItemList;
    local FoxDataStore_Unlockables UnlockablesDataStore;
    local class<FoxWeapon> TestWeapon;
    local FoxTypes.EPurchaseState PurchaseState;
    local FoxItemCacheInventory InventoryCache;
    local FoxWeaponConfigInfo OurWeaponInfo, OurOtherWeaponInfo;
    local int I;
    local bool bOwnedForAllReceivers, bDoesOwnAValidReceiver, bFoundUnownedGeneratedItem;
    local string AssociatedWeaponClassName;
    local FoxItemCacheLoadouts LoadoutsCache;
    local LoadoutInfoData LoadoutData;

    // End:0x136
    if(class'FoxDataStore_StoreData'.static.GetCachedLoadouts(LoadoutsCache) && LoadoutsCache.RetrieveLoadoutByID(Outer.PCOwner.ProfileSettings.GetDefaultLoadoutID(), LoadoutData))
    {
        FoxPRI(Outer.PCOwner.PlayerReplicationInfo).Loadout.BuildWeaponConfigInfoFromProfileSlot(LoadoutData.WeaponData, OurWeaponInfo, OurOtherWeaponInfo);
    }
    AssociatedUnlockID = 0;
    class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache);
    // End:0x2BC
    if((StoreItem.PackType != 0) && StoreItem.GeneratedItems.Length > 0)
    {
        I = 0;
        J0x1C0:
        // End:0x2AA [Loop If]
        if(I < StoreItem.GeneratedItems.Length)
        {
            PurchaseState = 0;
            // End:0x29C
            if(((InventoryCache != none) && InventoryCache.GetCachedItemWithBestPurchaseState(InvMetaData, StoreItem.GeneratedItems[I].ItemId, PurchaseState)) && PurchaseState != 4)
            {
                bFoundUnownedGeneratedItem = true;
                // [Explicit Break]
                goto J0x2AA;
            }
            ++ I;
            J0x2AA:
            // [Loop Continue]
            goto J0x1C0;
        }
        // End:0x2BC
        if(!bFoundUnownedGeneratedItem)
        {
            return 0;
        }
    }
    // End:0x355
    if((((InventoryCache != none) && InventoryCache.GetCachedItemByItemId(InvMetaData, StoreItem.ItemId, AssociatedUnlockID, PurchaseState)) && PurchaseState == 4) || PurchaseState == 3)
    {
        return 0;
    }
    // End:0x46A
    if(class'FoxUnlockInfo'.static.IsValidWeaponModType(StoreItem.UnlockType))
    {
        AssociatedUnlockID = OurWeaponInfo.WeaponClass.default.UnlockID;
        bDoesOwnAValidReceiver = DoesOwnAValidReceiverForMod(StoreItem.ItemId);
        bOwnedForAllReceivers = IsOwnedForAllOwnedReceivers(StoreItem.ItemId);
        // End:0x454
        if(bDoesOwnAValidReceiver && bOwnedForAllReceivers)
        {
            return 0;
        }
        // End:0x46A
        else
        {
            // End:0x467
            if(bDoesOwnAValidReceiver)
            {
                return 1;
            }
            // End:0x46A
            else
            {
                return 2;
            }
        }
    }
    // End:0x8E6
    if(StoreItem.UnlockType == 19)
    {
        UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
        // End:0x7F0
        if(UnlockablesDataStore != none)
        {
            I = 0;
            J0x4FD:
            // End:0x628 [Loop If]
            if(I < UnlockablesDataStore.PrimarySkinProviderArray.Length)
            {
                // End:0x61A
                if((UnlockablesDataStore.PrimarySkinProviderArray[I].UnlockID == StoreItem.ItemId) && UnlockablesDataStore.PrimarySkinProviderArray[I].WhiteRecievers.Length > 0)
                {
                    AssociatedWeaponClassName = UnlockablesDataStore.PrimarySkinProviderArray[I].WhiteRecievers[0];
                    // [Explicit Break]
                    goto J0x628;
                }
                ++ I;
                J0x628:
                // [Loop Continue]
                goto J0x4FD;
            }
            // End:0x76E
            if(AssociatedWeaponClassName == "")
            {
                I = 0;
                J0x643:
                // End:0x76E [Loop If]
                if(I < UnlockablesDataStore.SecondarySkinProviderArray.Length)
                {
                    // End:0x760
                    if((UnlockablesDataStore.SecondarySkinProviderArray[I].UnlockID == StoreItem.ItemId) && UnlockablesDataStore.SecondarySkinProviderArray[I].WhiteRecievers.Length > 0)
                    {
                        AssociatedWeaponClassName = UnlockablesDataStore.SecondarySkinProviderArray[I].WhiteRecievers[0];
                        // [Explicit Break]
                        goto J0x76E;
                    }
                    ++ I;
                    J0x76E:
                    // [Loop Continue]
                    goto J0x643;
                }
            }
            // End:0x7F0
            if(AssociatedWeaponClassName != "")
            {
                TestWeapon = class<FoxWeapon>(class'FoxLoadoutInfo'.static.ResolveWpnContentByName(AssociatedWeaponClassName));
                // End:0x7F0
                if(TestWeapon != none)
                {
                    AssociatedUnlockID = TestWeapon.default.UnlockID;
                }
            }
        }
        // End:0x8E6
        if((InventoryCache != none) && InventoryCache.GetCachedItems(InventoryItemList, StoreItem.ItemId))
        {
            I = 0;
            J0x857:
            // End:0x8E6 [Loop If]
            if(I < InventoryItemList.Length)
            {
                PurchaseState = class'FoxInventoryMetaData'.static.GetPurchaseState(InventoryItemList[I]);
                // End:0x8D8
                if((PurchaseState == 3) || PurchaseState == 4)
                {
                    return 0;
                }
                ++ I;
                // [Loop Continue]
                goto J0x857;
            }
        }
    }
    return 1;
    //return ReturnValue;    
}

function QuickTravelToStoreItem(int UnlockID)
{
    local bool bArmoryAlreadyOpen;

    // End:0x39B
    if(Outer.Menu != none)
    {
        // End:0x103
        if(!Outer.IsInEntryMap())
        {
            bErrorPopup = true;
            // End:0xAC
            if(MarketWidget != none)
            {
                MarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorInGameLabel);
            }
            // End:0x101
            else
            {
                // End:0x101
                if(LandingPageMarketWidget != none)
                {
                    LandingPageMarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorInGameLabel);
                }
            }
            return;
        }
        bArmoryAlreadyOpen = Outer.Menu.ArmoryInfo != none;
        // End:0x1D2
        if(!bArmoryAlreadyOpen)
        {
            Outer.Menu.ui_preloadArmory("", "menuOut");
            bMarketPreloadedArmory = true;
            Outer.Menu.ui_setupArmoryInfo();
        }
        // End:0x2DF
        if(Outer.Menu.ArmoryInfo.IsGridItem(UnlockID))
        {
            NavToItemID = UnlockID;
            Outer.CloseDialogBox();
            // End:0x29C
            if(MarketWidget != none)
            {
                MarketWidget.ShowNavPopup(LocNavToStoreTitle, LocNavToStoreBody);
            }
            // End:0x2DC
            else
            {
                // End:0x2DC
                if(LandingPageMarketWidget != none)
                {
                    LandingPageMarketWidget.ShowNavPopup(LocNavToStoreTitle, LocNavToStoreBody);
                }
            }
        }
        // End:0x398
        else
        {
            bErrorPopup = true;
            // End:0x343
            if(MarketWidget != none)
            {
                MarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorNotApplicableLabel);
            }
            // End:0x398
            else
            {
                // End:0x398
                if(LandingPageMarketWidget != none)
                {
                    LandingPageMarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorNotApplicableLabel);
                }
            }
        }
    }
    // End:0x454
    else
    {
        bErrorPopup = true;
        // End:0x3FF
        if(MarketWidget != none)
        {
            MarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
        }
        // End:0x454
        else
        {
            // End:0x454
            if(LandingPageMarketWidget != none)
            {
                LandingPageMarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
            }
        }
    }
    //return;    
}

function CleanUpPreloadedArmory()
{
    // End:0xFD
    if(((bMarketPreloadedArmory && Outer.Menu != none) && Outer.Menu.ArmoryInfo != none) && !bGoingToTravelToArmory)
    {
        Outer.Menu.ArmoryInfo.CloseArmory();
        Outer.Menu.ArmoryInfo = none;
    }
    bMarketPreloadedArmory = false;
    bGoingToTravelToArmory = false;
    //return;    
}

event TravelToStoreID()
{
    local int UnlockID;

    bGoingToTravelToArmory = true;
    // End:0x5C
    if(MarketWidget != none)
    {
        MarketWidget.HideErrorPopup();
        MarketWidget.as_transitionOutTravel();
    }
    // End:0x7B
    else
    {
        LandingPageMarketWidget.HideErrorPopup();
    }
    UnlockID = NavToItemID;
    NavToItemID = -1;
    Outer.as_transition("menuLeftKillChat");
    Outer.ui_SetCurrentTitle("Customization");
    Outer.Menu.as_addBackButton(-800, -255, "BackLabel");
    Outer.Menu.ui_addNewArmory(-627, -210, Outer.GetWorldInfo().NetMode != NM_Standalone);
    Outer.Menu.as_updateBackButton("BackButtonPreviousToolip", "menuOutReset", "ui_RunCommandGroup", "customizationFromGameToMainMenu", "", "customization-back");
    Outer.Menu.as_SetBackButtonLabel("CustomizationTitle");
    // End:0x331
    if(Outer.Menu.ArmoryObject != none)
    {
        Outer.Menu.ArmoryObject.as_TransitionInQuick();
    }
    Outer.Menu.ArmoryInfo.ui_addArmoryCategories();
    Outer.Menu.ArmoryInfo.OpenGridForItem(UnlockID);
    //return;    
}

function ei_clickFeaturedItem(string Index)
{
    local StoreMetaData ChosenFeatured;
    local FoxQuickMarketUI.ECanPurchaseError PurchaseError;
    local int AssociatedUnlockID;

    AssociatedUnlockID = 0;
    // End:0x2D
    if((MarketWidget == none) && LandingPageMarketWidget == none)
    {
        return;
    }
    // End:0x86
    if(MarketWidget != none)
    {
        ChosenFeatured = MarketWidget.FeaturedItems[int(Index)].StoreItem;
    }
    // End:0xCD
    else
    {
        ChosenFeatured = LandingPageMarketWidget.FeaturedItems[int(Index)].StoreItem;
    }
    PurchaseError = CanPurchase(ChosenFeatured, AssociatedUnlockID);
    // End:0x184
    if(PurchaseError == 1)
    {
        Outer.PurchaseItemByStoreItem(ChosenFeatured, 0, FeaturedPurchaseComplete,,,,, AssociatedUnlockID, NonNavigableUnlockTypes.Find(ChosenFeatured.UnlockType) == -1);
    }
    // End:0x2AF
    else
    {
        // End:0x2AF
        if(PurchaseError == 0)
        {
            // End:0x1F6
            if(NonNavigableUnlockTypes.Find(ChosenFeatured.UnlockType) == -1)
            {
                QuickTravelToStoreItem(ChosenFeatured.ItemId);
            }
            // End:0x2AF
            else
            {
                bErrorPopup = true;
                // End:0x25A
                if(MarketWidget != none)
                {
                    MarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
                }
                // End:0x2AF
                else
                {
                    // End:0x2AF
                    if(LandingPageMarketWidget != none)
                    {
                        LandingPageMarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
                    }
                }
            }
        }
    }
    //return;    
}

function ei_clickItemTile(string Index)
{
    local StoreMetaData ChosenTile;
    local FoxQuickMarketUI.ECanPurchaseError PurchaseError;
    local int AssociatedUnlockID;

    AssociatedUnlockID = 0;
    // End:0x2D
    if((MarketWidget == none) && LandingPageMarketWidget == none)
    {
        return;
    }
    // End:0x86
    if(MarketWidget != none)
    {
        ChosenTile = MarketWidget.ItemTiles[int(Index)].StoreItem;
    }
    // End:0xCD
    else
    {
        ChosenTile = LandingPageMarketWidget.ItemTiles[int(Index)].StoreItem;
    }
    PurchaseError = CanPurchase(ChosenTile, AssociatedUnlockID);
    // End:0x184
    if(PurchaseError == 1)
    {
        Outer.PurchaseItemByStoreItem(ChosenTile, 0, TilePurchaseComplete,,,,, AssociatedUnlockID, NonNavigableUnlockTypes.Find(ChosenTile.UnlockType) == -1);
    }
    // End:0x2AF
    else
    {
        // End:0x2AF
        if(PurchaseError == 0)
        {
            // End:0x1F6
            if(NonNavigableUnlockTypes.Find(ChosenTile.UnlockType) == -1)
            {
                QuickTravelToStoreItem(ChosenTile.ItemId);
            }
            // End:0x2AF
            else
            {
                bErrorPopup = true;
                // End:0x25A
                if(MarketWidget != none)
                {
                    MarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
                }
                // End:0x2AF
                else
                {
                    // End:0x2AF
                    if(LandingPageMarketWidget != none)
                    {
                        LandingPageMarketWidget.ShowErrorPopup(Outer.LocFailureLabel, LocErrorAlreadyOwned);
                    }
                }
            }
        }
    }
    //return;    
}

function FeaturedPurchaseComplete(bool bSuccess, optional bool bUnused)
{
    local FoxItemCacheInventory InventoryCache;
    local array<string> URLs;

    // End:0x23B
    if(bSuccess)
    {
        MarketWidget.RefreshItemTiles(true, false, URLs);
        LandingPageMarketWidget.RefreshItemTiles(true, false, URLs);
        SetImagesNeeded(URLs);
        // End:0x11D
        if((Outer.Menu != none) && Outer.Menu.ArmoryInfo != none)
        {
            Outer.Menu.ArmoryInfo.QuickRefresh();
        }
        class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache);
        // End:0x193
        if(InventoryCache != none)
        {
            InventoryCache.MergeUpdatedItems(true);
            InventoryCache.SynchronizeCachedInventoryItemsBeforeUpdate();
        }
        // End:0x23B
        if((Outer.Menu != none) && Outer.Menu.PlayerCard != none)
        {
            Outer.Menu.PlayerCard.SetGPDoublerIcon();
        }
    }
    //return;    
}

function TilePurchaseComplete(bool bSuccess, optional bool bUnused)
{
    local FoxItemCacheInventory InventoryCache;
    local array<string> URLs;

    // End:0x23B
    if(bSuccess)
    {
        MarketWidget.RefreshItemTiles(false, true, URLs);
        LandingPageMarketWidget.RefreshItemTiles(false, true, URLs);
        SetImagesNeeded(URLs);
        // End:0x11D
        if((Outer.Menu != none) && Outer.Menu.ArmoryInfo != none)
        {
            Outer.Menu.ArmoryInfo.QuickRefresh();
        }
        class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache);
        // End:0x193
        if(InventoryCache != none)
        {
            InventoryCache.MergeUpdatedItems(true);
            InventoryCache.SynchronizeCachedInventoryItemsBeforeUpdate();
        }
        // End:0x23B
        if((Outer.Menu != none) && Outer.Menu.PlayerCard != none)
        {
            Outer.Menu.PlayerCard.SetGPDoublerIcon();
        }
    }
    //return;    
}

defaultproperties
{
    LocErrorAlreadyOwned="Cannot purchase.  Item already owned."
    LocErrorInGameLabel="Cannot navigate to store while in game."
    LocErrorNotApplicableLabel="This item is not applicable to your current loadout. Please change your current loadout."
    LocNavToStoreTitle="Navigate to Customization?"
    LocNavToStoreBody="Would you like to navigate to this item in customization?"
    LocPurchaseCurrencyTitle="PURCHASE ZCOINS"
    LocPurchaseCurrencyBody_Pending="Pending.."
    LocPurchaseCurrencyBody_Complete="Purchase complete!"
    LocPurchaseCurrencyBody_Failed="Purchase canceled or failed."
    NavToItemID=-1
    NonNavigableUnlockTypes(0)=0
    NonNavigableUnlockTypes(1)=1
    NonNavigableUnlockTypes(2)=2
    NonNavigableUnlockTypes(3)=3
    NonNavigableUnlockTypes(4)=4
    NonNavigableUnlockTypes(5)=5
    NonNavigableUnlockTypes(6)=6
    NonNavigableUnlockTypes(7)=7
    NonNavigableUnlockTypes(8)=10
    NonNavigableUnlockTypes(9)=11
    NonNavigableUnlockTypes(10)=12
    NonNavigableUnlockTypes(11)=15
    NonNavigableUnlockTypes(12)=16
    NonNavigableUnlockTypes(13)=17
    NonNavigableUnlockTypes(14)=18
    NonNavigableUnlockTypes(15)=34
    NonNavigableUnlockTypes(16)=44
    NonNavigableUnlockTypes(17)=45
    NonNavigableUnlockTypes(18)=46
    NonNavigableUnlockTypes(19)=47
    NonNavigableUnlockTypes(20)=48
    NonNavigableUnlockTypes(21)=49
    NonNavigableUnlockTypes(22)=50
}